/* -----------------------------------------------------------------------------
 * Copyright (c) 2017 ARM Ltd.
 *
 * This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising from
 * the use of this software. Permission is granted to anyone to use this
 * software for any purpose, including commercial applications, and to alter
 * it and redistribute it freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software in
 *    a product, an acknowledgment in the product documentation would be
 *    appreciated but is not required.
 *
 * 2. Altered source versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.
 *
 * 3. This notice may not be removed or altered from any source distribution.
 *
 *
 * $Date:        07. December 2017
 * $Revision:    V1.1.0
 *
 * Project:      Flash Device Description for S32K
 * --------------------------------------------------------------------------- */

/* History:
 *  Version 1.1.0
 *    Added "S32K148 512KB DFlash (4KB Sector)".
 *  Version 1.0.0
 *    Initial release
 */

#include "..\FlashOS.H"        /* FlashOS Structures */

#if   defined (S32K116)

  #ifdef P128_2KB_SEC
  struct FlashDevice const FlashDevice  =  {
      FLASH_DRV_VERS,                     /* Driver Version, do not modify! */
      "S32K116 128KB PFlash (2KB Sector)",/* Device Name */
      ONCHIP,                             /* Device Type */
      0x00000000,                         /* Device Start Address */
      0x00020000,                         /* Device Size (128kB) */
      1024,                               /* Programming Page Size */
      0,                                  /* Reserved, must be 0 */
      0xFF,                               /* Initial Content of Erased Memory */
      1000,                               /* Program Page Timeout 1000 mSec */
      3000,                               /* Erase Sector Timeout 3000 mSec */
      /* Specify Size and Address of Sectors */
      0x000800, 0x000000,                 /* Sector Size  2kB (128 Sectors) */
      SECTOR_END
  };
  #endif


#endif /* S32K116 */
