#ifndef I2C_PAL_CFG_H
#define I2C_PAL_CFG_H

/*
//-------- <<< Use Configuration Wizard in Context Menu >>> ------------------
*/

// <e> I2C over LPI2C
//   <o1>Number of I2C over LPI2C instances  <1-10>
// </e>
#define I2C_LPI2C__         0U
#define I2C_LPI2C_NO__      1U

// <e> I2C over FlexIO
//   <o1>Number of I2C over FlexIO instances  <1-10>
// </e>
#define I2C_FLEXIO__        0U
#define I2C_FLEXIO_NO__     1U


/*
//-------- <<< end of configuration section >>> ------------------------------
*/


#if defined(I2C_LPI2C__) && (I2C_LPI2C__ == 1)
  #define I2C_OVER_LPI2C
  #define NO_OF_LPI2C_INSTS_FOR_I2C       I2C_LPI2C_NO__
#endif


#if defined(I2C_FLEXIO__) && (I2C_FLEXIO__ == 1)
  #define I2C_OVER_FLEXIO
  #define NO_OF_FLEXIO_INSTS_FOR_I2C      I2C_FLEXIO_NO__
#endif

#endif /* I2C_PAL_CFG_H */
